%{
  open Ast
%}

%token EOF LAM DOT LPAREN RPAREN LET COMPUTE EQUALS
%token<string> ID

%start program
%type < Ast.top_level list > program

%%

program 
  : top_level
    { $1 }
  ;

top_level
  : EOF
    { [] }
  | LET ID EQUALS term top_level
    { Let ($2, $4) :: $5 }
  | COMPUTE term top_level
    { Compute $2 :: $3 }
  ;
  
term
  : LAM lambda
    { $2 }
  | app
    { $1 }
  ;

lambda 
  : DOT term
    { $2 }
  | ID lambda
    { Abs ($1, $2) }
  ;

app
  : app factor
    { App ($1, $2) }
  | factor
    { $1 }
  ;

factor
  : ID
    { Var $1 }
  | LPAREN term RPAREN
    { $2 }
  ;

%%
